/*
   File: contsens.h
   Does context dependent analysis

   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: contsens.h,v 1.9 2008/06/28 13:38:28 marcs Exp $"
*/
#ifndef IncContSens
#define IncContSens

/* libdcg and local includes */
#include <dcg.h>
#include "cdl_ds.h"

/* exported module fname */
extern string contsens_fname;

/* exported code */
void context_sensitive_analysis ();
void contsens_error (module mod, int line, int col, char *format, ...);
void contsens_error_by_mnr (int mnr, int line, int col, char *format, ...);
void contsens_warning (module mod, int line, int col, char *format, ...);
void contsens_warning_by_mnr (int mnr, int line, int col, char *format, ...);
void contsens_hint (module mod, int line, int col, char *format, ...);
void contsens_hint_by_mnr (int mnr, int line, int col, char *format, ...);
void pass2_error (module mod, int line, int column);

#endif /* IncContSens */
