/*
   File: globals.h
   Defines and holds the 4 global datastructures of the MCDL compiler

   Copyright (C) 2010 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: globals.h,v 1.1 2010/06/12 12:54:24 marcs Exp $"
*/
#ifndef IncGlobals
#define IncGlobals

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"

/* List of all modules and pointer to the root */
extern module_list all_modules;
extern module root_module;

/* List of all affix rule definitions, but not imports */
extern affix_rule_list all_affix_rules;

/* List of all procedures */
extern proc_list all_procedures;

/* List of all global variables */
extern variable_list all_global_variables;

/* Initialisation */
void init_globals ();

#endif /* IncGlobals */
