/*
   File: modules.h
   Maintains and checks the list of all modules.

   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: modules.h,v 1.4 2010/06/12 12:54:24 marcs Exp $"
*/
#ifndef IncModules
#define IncModules

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"

/* The name of the standard packet is predef.cdl3 */
#define PREDEF_NAME "predef"

/* Module addition and lookup */
void register_module (module mod);
module identify_module (string mname);

/* Check for root rules */
void check_modules ();
void dump_modules ();

#endif /* IncModules */
