/*
   File: variables.h
   Checks variables

   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: variables.h,v 1.16 2010/06/12 12:54:24 marcs Exp $"
*/
#ifndef IncVariables
#define IncVariables

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"

/* Checking of module variables */
void check_global_variables ();

/* Checking of formal arguments */
void check_spec_formals (spec pspec, module mod, psig_list *p1sig, psig_list *p2sig);
void check_proc_formals (spec pspec, module mod,
			 variable_list *pvars, psig_list *p1sig, psig_list *p2sig);

/* Checking of expressions */
int is_an_affix_variable (affix_term term);
int is_a_single_affix_variable (affix_term_list terms);
int is_a_simple_affix_variable (affix_term_list terms);
affix_rule check_affix_variable (affix_term term, variable_list pvars, module mod);
affix_rule check_expr (affix_term_list terms, variable_list pvars, module mod);
void simplify_affix_terms (affix_term_list terms, proc p);

/* Needed to allocate unique local affixes */
variable var_from_affix_term (affix_term term);
affix_term new_local_affix (int line, int col, affix_rule arule);
variable new_local_var (affix_rule rule);

/* Flow checking */
int is_a_global_variable (affix_term term);

#endif /* IncVariables */
