/*
   File: mrts_test.c
   Tests the mcdl runtime system

   Copyright (C) 2008 Marc Seutter

   This library is free software: you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published   
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU Lesser General Public License
   along with this library.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: mrts_test.c,v 1.10 2008/06/28 13:52:07 marcs Exp $"
*/

/* global includes */
#include <stdio.h>

/* local include */
#include "mrts_mcdl.h"
#include "mrts_stdtypes.h"
#include "mrts_predef.h"

static Array G_LABELS = InitArray;
static value G_00 = InitValue;
static union v_heap_uni TC0[2] = {{.adm = {-1,Tag_TEXT}}, {.vtext = "Hello"}};

static void check_sizes (void)
{ fprintf (stderr, "Size of long: %d\n", sizeof (long));
  fprintf (stderr, "Size of double: %d\n", sizeof (double));
  fprintf (stderr, "Size of heap_vptr: %d\n", sizeof (heap_vptr));
  fprintf (stderr, "Size of value: %d\n", sizeof (value));
  fprintf (stderr, "Size of rts_adm: %d\n", sizeof (rts_adm));
  fprintf (stderr, "Size of array: %d\n", sizeof (Array));
}

static void mcdl_main (void)
{ value L4 = Create_INT (-42L);
  value L8 = Create_TEXT ("Hello ");
  value L12 = Create_TEXT ("world\n");
  value L20 = ValueCast (TC0);
  value *PL0 = mrts_index_array (&G_LABELS, 767L);
  value L16;
  mrts_command_arg_INT_TEXT (Create_INT (0L), &L16);
  fprintf (stderr, "value of L4 is: ");
  Write_INT (L4);
  fprintf (stderr, "\n");
  Attach_TEXT (L8);
  *PL0 = mrts_concat_text (L8, L12);
  fprintf (stderr, "value of LABELS[767] is: ");
  mrts_write_TEXT (*PL0);
  fprintf (stderr, "command arg [0] is: ");
  mrts_write_TEXT (L16);
  Detach_INT(L4);
};

int main (int argc, char **argv)
{ mrts_init_basic ();
  mrts_init_predef (argc, argv);
  check_sizes ();
  mcdl_main ();
  return (0);
}
